/**
 * 
 */
package de.urszeidler.eclipse.callchain.diagram;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.commands.IHandler;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchSite;
import org.eclipse.ui.handlers.HandlerUtil;

import de.urszeidler.eclipse.callchain.diagram.part.ValidateAction;

/**
 * @author urs
 *
 */
public class ValidateActionHandler extends AbstractHandler implements IHandler {

	/* (non-Javadoc)
	 * @see org.eclipse.core.commands.IHandler#execute(org.eclipse.core.commands.ExecutionEvent)
	 */
//	@Override
	public Object execute(ExecutionEvent event) throws ExecutionException {
		//ISelection selection = HandlerUtil.getCurrentSelection(event);
		IWorkbenchSite activeSite = HandlerUtil.getActiveSite(event);
		IWorkbenchPage page = activeSite.getPage();

		
		
		ValidateAction validateAction = new ValidateAction(page);
		validateAction.run();
		return null;
	}

}
