/**
 * 
 */
package de.urszeidler.eclipse.callchain.generatorservice;

import java.util.ArrayList;
import java.util.List;

/**
 * @author urs
 *
 */
public class Category {
	private String id;
	private String name;
	private String description;
	private List<GeneratorDescriptor> descriptors = new ArrayList<GeneratorDescriptor>();
	
	public Category(String name, String description) {
		super();
		this.id = name;
		this.name = name;
		this.description = description;
	}
	public Category() {
		super();
	}
	public String getId() {
		return id;
	}
	public void setId(String id) {
		this.id = id;
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public String getDescription() {
		return description;
	}
	public void setDescription(String description) {
		this.description = description;
	}
	public List<GeneratorDescriptor> getDescriptors() {
		return descriptors;
	}
	public void setDescriptors(List<GeneratorDescriptor> descriptors) {
		this.descriptors = descriptors;
	}
}
