/**
 * Generated with Acceleo
 */
package de.urszeidler.eclipse.callchain.parts.forms;

import java.util.Collections;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.edit.domain.AdapterFactoryEditingDomain;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.emf.edit.ui.provider.AdapterFactoryLabelProvider;
import org.eclipse.emf.eef.runtime.api.component.IPropertiesEditionComponent;
import org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.api.parts.IFormPropertiesEditionPart;
import org.eclipse.emf.eef.runtime.impl.components.StandardPropertiesEditionComponent;
import org.eclipse.emf.eef.runtime.impl.notify.PropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.impl.parts.CompositePropertiesEditionPart;
import org.eclipse.emf.eef.runtime.ui.parts.PartComposer;
import org.eclipse.emf.eef.runtime.ui.parts.sequence.BindingCompositionSequence;
import org.eclipse.emf.eef.runtime.ui.parts.sequence.CompositionSequence;
import org.eclipse.emf.eef.runtime.ui.parts.sequence.CompositionStep;
import org.eclipse.emf.eef.runtime.ui.utils.EditingUtils;
import org.eclipse.emf.eef.runtime.ui.widgets.ButtonsModeEnum;
import org.eclipse.emf.eef.runtime.ui.widgets.EObjectFlatComboViewer;
import org.eclipse.emf.eef.runtime.ui.widgets.FormUtils;
import org.eclipse.emf.eef.runtime.ui.widgets.eobjflatcombo.EObjectFlatComboSettings;
import org.eclipse.emf.eef.runtime.ui.wizards.PropertiesEditionWizard;
import org.eclipse.emf.transaction.impl.InternalTransaction;
import org.eclipse.emf.transaction.impl.InternalTransactionalEditingDomain;
import org.eclipse.jface.viewers.ISelectionChangedListener;
import org.eclipse.jface.viewers.SelectionChangedEvent;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.jface.viewers.ViewerFilter;
import org.eclipse.jface.wizard.WizardDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.FocusAdapter;
import org.eclipse.swt.events.FocusEvent;
import org.eclipse.swt.events.KeyAdapter;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.forms.widgets.Form;
import org.eclipse.ui.forms.widgets.FormToolkit;
import org.eclipse.ui.forms.widgets.ScrolledForm;
import org.eclipse.ui.forms.widgets.Section;

import de.urszeidler.eclipse.callchain.parts.CallchainViewsRepository;
import de.urszeidler.eclipse.callchain.parts.PredicateSwitchPropertiesEditionPart;
import de.urszeidler.eclipse.callchain.providers.CallchainMessages;

/**
 * @author Urs Zeidler
 * @generated
 */
public class PredicateSwitchPropertiesEditionPartForm extends
		CompositePropertiesEditionPart implements IFormPropertiesEditionPart,
		PredicateSwitchPropertiesEditionPart {

	protected Text name;
	protected EObjectFlatComboViewer predicate;

	/**
	 * Default constructor
	 * 
	 * @param editionComponent
	 *            the {@link IPropertiesEditionComponent} that manage this part
	 * @generated
	 */
	public PredicateSwitchPropertiesEditionPartForm(
			IPropertiesEditionComponent editionComponent) {
		super(editionComponent);
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.parts.IFormPropertiesEditionPart#
	 *      createFigure(org.eclipse.swt.widgets.Composite,
	 *      org.eclipse.ui.forms.widgets.FormToolkit)
	 * @generated
	 */
	public Composite createFigure(final Composite parent,
			final FormToolkit widgetFactory) {
		ScrolledForm scrolledForm = widgetFactory.createScrolledForm(parent);
		Form form = scrolledForm.getForm();
		view = form.getBody();
		GridLayout layout = new GridLayout();
		layout.numColumns = 3;
		view.setLayout(layout);
		createControls(widgetFactory, view);
		return scrolledForm;
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.parts.IFormPropertiesEditionPart#
	 *      createControls(org.eclipse.ui.forms.widgets.FormToolkit,
	 *      org.eclipse.swt.widgets.Composite)
	 * @generated
	 */
	public void createControls(final FormToolkit widgetFactory, Composite view) {
		CompositionSequence predicateSwitchStep = new BindingCompositionSequence(
				propertiesEditionComponent);
		CompositionStep propertiesStep = predicateSwitchStep
				.addStep(CallchainViewsRepository.PredicateSwitch.Properties.class);
		propertiesStep
				.addStep(CallchainViewsRepository.PredicateSwitch.Properties.name);
		propertiesStep
				.addStep(CallchainViewsRepository.PredicateSwitch.Properties.predicate);

		composer = new PartComposer(predicateSwitchStep) {

			@Override
			public Composite addToPart(Composite parent, Object key) {
				if (key == CallchainViewsRepository.PredicateSwitch.Properties.class) {
					return createPropertiesGroup(widgetFactory, parent);
				}
				if (key == CallchainViewsRepository.PredicateSwitch.Properties.name) {
					return createNameText(widgetFactory, parent);
				}
				if (key == CallchainViewsRepository.PredicateSwitch.Properties.predicate) {
					return createPredicateFlatComboViewer(parent, widgetFactory);
				}
				return parent;
			}
		};
		composer.compose(view);
	}

	/**
	 * @generated
	 */
	protected Composite createPropertiesGroup(FormToolkit widgetFactory,
			final Composite parent) {
		Section propertiesSection = widgetFactory.createSection(parent,
				Section.TITLE_BAR | Section.TWISTIE | Section.EXPANDED);
		propertiesSection
				.setText(CallchainMessages.PredicateSwitchPropertiesEditionPart_PropertiesGroupLabel);
		GridData propertiesSectionData = new GridData(GridData.FILL_HORIZONTAL);
		propertiesSectionData.horizontalSpan = 3;
		propertiesSection.setLayoutData(propertiesSectionData);
		Composite propertiesGroup = widgetFactory
				.createComposite(propertiesSection);
		GridLayout propertiesGroupLayout = new GridLayout();
		propertiesGroupLayout.numColumns = 3;
		propertiesGroup.setLayout(propertiesGroupLayout);
		propertiesSection.setClient(propertiesGroup);
		return propertiesGroup;
	}

	/**
	 * @generated
	 */

	protected Composite createNameText(FormToolkit widgetFactory,
			Composite parent) {
		FormUtils
				.createPartLabel(
						widgetFactory,
						parent,
						CallchainMessages.PredicateSwitchPropertiesEditionPart_NameLabel,
						propertiesEditionComponent
								.isRequired(
										CallchainViewsRepository.PredicateSwitch.Properties.name,
										CallchainViewsRepository.FORM_KIND));
		name = widgetFactory.createText(parent, ""); //$NON-NLS-1$
		name.setData(FormToolkit.KEY_DRAW_BORDER, FormToolkit.TEXT_BORDER);
		widgetFactory.paintBordersFor(parent);
		GridData nameData = new GridData(GridData.FILL_HORIZONTAL);
		name.setLayoutData(nameData);
		name.addFocusListener(new FocusAdapter() {
			/**
			 * @see org.eclipse.swt.events.FocusAdapter#focusLost(org.eclipse.swt.events.FocusEvent)
			 * @generated
			 */
			@Override
			@SuppressWarnings("synthetic-access")
			public void focusLost(FocusEvent e) {
				if (propertiesEditionComponent != null)
					propertiesEditionComponent
							.firePropertiesChanged(new PropertiesEditionEvent(
									PredicateSwitchPropertiesEditionPartForm.this,
									CallchainViewsRepository.PredicateSwitch.Properties.name,
									PropertiesEditionEvent.COMMIT,
									PropertiesEditionEvent.SET, null, name
											.getText()));
			}
		});
		name.addKeyListener(new KeyAdapter() {
			/**
			 * @see org.eclipse.swt.events.KeyAdapter#keyPressed(org.eclipse.swt.events.KeyEvent)
			 * @generated
			 */
			@Override
			@SuppressWarnings("synthetic-access")
			public void keyPressed(KeyEvent e) {
				if (e.character == SWT.CR) {
					if (propertiesEditionComponent != null)
						propertiesEditionComponent
								.firePropertiesChanged(new PropertiesEditionEvent(
										PredicateSwitchPropertiesEditionPartForm.this,
										CallchainViewsRepository.PredicateSwitch.Properties.name,
										PropertiesEditionEvent.COMMIT,
										PropertiesEditionEvent.SET, null, name
												.getText()));
				}
			}
		});
		EditingUtils.setID(name,
				CallchainViewsRepository.PredicateSwitch.Properties.name);
		EditingUtils.setEEFtype(name, "eef::Text"); //$NON-NLS-1$
		FormUtils
				.createHelpButton(
						widgetFactory,
						parent,
						propertiesEditionComponent
								.getHelpContent(
										CallchainViewsRepository.PredicateSwitch.Properties.name,
										CallchainViewsRepository.FORM_KIND),
						null); //$NON-NLS-1$
		return parent;
	}

	/**
	 * @param parent
	 *            the parent composite
	 * @param widgetFactory
	 *            factory to use to instanciante widget of the form
	 * @generated not
	 */
	protected Composite createPredicateFlatComboViewer(Composite parent,
			FormToolkit widgetFactory) {
		FormUtils
				.createPartLabel(
						widgetFactory,
						parent,
						CallchainMessages.PredicateSwitchPropertiesEditionPart_PredicateLabel,
						propertiesEditionComponent
								.isRequired(
										CallchainViewsRepository.PredicateSwitch.Properties.predicate,
										CallchainViewsRepository.FORM_KIND));
		// predicate = new EObjectFlatComboViewer(parent,
		// !propertiesEditionComponent.isRequired(CallchainViewsRepository.PredicateSwitch.Properties.predicate,
		// CallchainViewsRepository.FORM_KIND));
		predicate = new EObjectFlatComboViewer(parent, true) // ;
		{

			protected org.eclipse.swt.events.SelectionAdapter getSelectionAdapter(
					final boolean nullable) {
				return new SelectionAdapter() {

					/*
					 * (non-Javadoc)
					 * 
					 * @see
					 * org.eclipse.swt.events.SelectionAdapter#widgetSelected
					 * (org.eclipse .swt.events.SelectionEvent)
					 */
					public void widgetSelected(SelectionEvent e) {

						if (input instanceof EObjectFlatComboSettings) {
							EObjectFlatComboSettings i = (EObjectFlatComboSettings) input;
							Object value = i.getSource().eGet(
									i.getLastReference());
							final EObject eValue = (EObject) value;

							if (value == null) {
								EObject eObject = propertiesEditionComponent
										.getEditingContext().getEObject();
								EditingDomain editingDomain = AdapterFactoryEditingDomain
										.getEditingDomainFor(eObject);


								InternalTransaction a = ((InternalTransactionalEditingDomain) editingDomain)
										.getActiveTransaction();
								try {
									((InternalTransactionalEditingDomain) editingDomain)
											.startTransaction(false,
													Collections.EMPTY_MAP);
								} catch (InterruptedException e1) {
									// TODO Auto-generated catch block
									e1.printStackTrace();
								}

								PropertiesEditionEvent event = new PropertiesEditionEvent(
										PredicateSwitchPropertiesEditionPartForm.this,
										CallchainViewsRepository.PredicateSwitch.Properties.predicate,
										PropertiesEditionEvent.CHANGE,
										PropertiesEditionEvent.ADD, null, null);
								((StandardPropertiesEditionComponent) propertiesEditionComponent)
										.updateSemanticModel(event);


							} else {

								PropertiesEditionWizard wizard = new PropertiesEditionWizard(
										propertiesEditionComponent
												.getEditingContext(),
										adapterFactory, eValue);

								WizardDialog wDialog = new WizardDialog(
										getShell(), wizard);

								// EEFWizardDialog wDialog = new
								// EEFWizardDialog(EditingUtils.getShell(),
								// wizard);
								int open = wDialog.open();
							}

							//
							// EMFModelViewerDialog dialog = new
							// EMFModelViewerDialog(labelProvider, input,
							// filters.isEmpty() ? null : filters,
							// bpFilters.isEmpty() ? null
							// : bpFilters, nullable, false) {
							//
							// public void process(IStructuredSelection
							// selection) {
							// if (selection == null) {
							// selectedElement = null;
							// initComponent();
							// selectionChanged(new
							// StructuredSelection(Collections.EMPTY_LIST));
							// } else {
							// selectedElement = selection.getFirstElement();
							// initComponent();
							// if (selectedElement != null)
							// selectionChanged(new
							// StructuredSelection(selectedElement));
							// else
							// selectionChanged(new
							// StructuredSelection(Collections.EMPTY_LIST));
							// }
							// }
							// };
							// dialog.open();
						}
					}
				};

			};
		};

		widgetFactory.adapt(predicate);
		predicate.setLabelProvider(new AdapterFactoryLabelProvider(
				adapterFactory));
		GridData predicateData = new GridData(GridData.FILL_HORIZONTAL);
		predicate.setLayoutData(predicateData);
		predicate.addSelectionChangedListener(new ISelectionChangedListener() {

			/**
			 * {@inheritDoc}
			 * 
			 * @see org.eclipse.jface.viewers.ISelectionChangedListener#selectionChanged(org.eclipse.jface.viewers.SelectionChangedEvent)
			 */
			public void selectionChanged(SelectionChangedEvent event) {
				if (propertiesEditionComponent != null)
					propertiesEditionComponent
							.firePropertiesChanged(new PropertiesEditionEvent(
									PredicateSwitchPropertiesEditionPartForm.this,
									CallchainViewsRepository.PredicateSwitch.Properties.predicate,
									PropertiesEditionEvent.COMMIT,
									PropertiesEditionEvent.SET, null,
									getPredicate()));
			}

		});
		predicate
				.setID(CallchainViewsRepository.PredicateSwitch.Properties.predicate);
		FormUtils
				.createHelpButton(
						widgetFactory,
						parent,
						propertiesEditionComponent
								.getHelpContent(
										CallchainViewsRepository.PredicateSwitch.Properties.predicate,
										CallchainViewsRepository.FORM_KIND),
						null); //$NON-NLS-1$
		return parent;
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionListener#firePropertiesChanged(org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent)
	 * @generated
	 */
	public void firePropertiesChanged(IPropertiesEditionEvent event) {
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.PredicateSwitchPropertiesEditionPart#getName()
	 * @generated
	 */
	public String getName() {
		return name.getText();
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.PredicateSwitchPropertiesEditionPart#setName(String
	 *      newValue)
	 * @generated
	 */
	public void setName(String newValue) {
		if (newValue != null) {
			name.setText(newValue);
		} else {
			name.setText(""); //$NON-NLS-1$
		}
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.PredicateSwitchPropertiesEditionPart#getPredicate()
	 * @generated
	 */
	public EObject getPredicate() {
		if (predicate.getSelection() instanceof StructuredSelection) {
			Object firstElement = ((StructuredSelection) predicate
					.getSelection()).getFirstElement();
			if (firstElement instanceof EObject)
				return (EObject) firstElement;
		}
		return null;
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.PredicateSwitchPropertiesEditionPart#initPredicate(EObjectFlatComboSettings)
	 */
	public void initPredicate(EObjectFlatComboSettings settings) {
		predicate.setInput(settings);
		if (current != null) {
			predicate
					.setSelection(new StructuredSelection(settings.getValue()));
		}
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.PredicateSwitchPropertiesEditionPart#setPredicate(EObject
	 *      newValue)
	 * @generated
	 */
	public void setPredicate(EObject newValue) {
		if (newValue != null) {
			predicate.setSelection(new StructuredSelection(newValue));
		} else {
			predicate.setSelection(new StructuredSelection()); //$NON-NLS-1$
		}
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.PredicateSwitchPropertiesEditionPart#setPredicateButtonMode(ButtonsModeEnum
	 *      newValue)
	 */
	public void setPredicateButtonMode(ButtonsModeEnum newValue) {
		predicate.setButtonMode(newValue);
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.PredicateSwitchPropertiesEditionPart#addFilterPredicate(ViewerFilter
	 *      filter)
	 * @generated
	 */
	public void addFilterToPredicate(ViewerFilter filter) {
		predicate.addFilter(filter);
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.PredicateSwitchPropertiesEditionPart#addBusinessFilterPredicate(ViewerFilter
	 *      filter)
	 * @generated
	 */
	public void addBusinessFilterToPredicate(ViewerFilter filter) {
		predicate.addBusinessRuleFilter(filter);
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.parts.IPropertiesEditionPart#getTitle()
	 * @generated
	 */
	public String getTitle() {
		return CallchainMessages.PredicateSwitch_Part_Title;
	}

}
