/**
 * 
 */
package de.urszeidler.eclipse.callchain.tabbedpropery.sections;

import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecoretools.tabbedproperties.sections.AbstractStringPropertySection;

import de.urszeidler.eclipse.callchain.CallchainPackage;

/**
 * @author urs
 *
 */
public class GenericGeneratorIdSection extends AbstractStringPropertySection {

	/* (non-Javadoc)
	 * @see org.eclipse.emf.ecoretools.tabbedproperties.sections.AbstractTabbedPropertySection#getFeature()
	 */
	@Override
	protected EStructuralFeature getFeature() {
		return CallchainPackage.eINSTANCE.getGeneric_Generator_Id();
	}

	/* (non-Javadoc)
	 * @see org.eclipse.emf.ecoretools.tabbedproperties.sections.AbstractTabbedPropertySection#getLabelText()
	 */
	@Override
	protected String getLabelText() {
		return "id :";
	}

}
